@minimal @ci_job @setup
Feature: Create a Drupal role for OpenStack and a user as "Administrator"

  @api
  Scenario: Create a role
    Given I am logged in as a user with the "Administrator" role
    When I visit "/admin/people/roles/add"
    And I enter "{{ drupal_role_name }}" for "Role name"
    And I enter "{{ drupal_role_name_machine }}" for "Machine-readable name"
    And I press "Save"
    And I should be on "/admin/people/roles"
    And I should see "{{ drupal_role_name }}"
    Then I visit "admin/people/permissions/{{ drupal_role_name_machine }}"
    # Allow to see the cloud service provider
    And I check the box "Access {{ cloud_service_provider_name }}"
    # Allow to delete resources as workaround
    # This permission is temporary once perimission is fixed we don't have to
    # add perimission
    And I check the box "Delete any OpenStack security group"
    And I check the box "View any OpenStack security group"
    And I check the box "Edit any OpenStack security group"
    # Allow to view and Edit private image by public image case
    And I check the box "View any OpenStack image"
    And I check the box "Edit any OpenStack image"
    # Allow to view an instance
    And I check the box "View any OpenStack instance"
    And I check the box "Delete / Terminate any OpenStack instance"
    # Allow to launch an instance.
    And I check the box "Launch approved cloud launch template"
    And I check the box "Delete own cloud launch templates"
    And I press "Save permissions"
    And I should see the success message "The changes have been saved."
    And I should see neither error nor warning messages

  @api
  Scenario: Create a user
    Given I am logged in as a user with the "Administrator" role
    When I visit "/admin/people/create"
    And I enter "{{ drupal_user_name }}" for "Username"
    And I enter "{{ drupal_user_password }}" for "Password"
    And I enter "{{ drupal_user_password }}" for "Confirm password"
    And I check the box "{{ drupal_role_name }}"
    And I press "Create new account"
    Then I should see the success message "Created a new user account for"
    And I should see neither error nor warning messages
    And I visit "/admin/people"
    And I should see "{{ drupal_user_name }}"
