@minimal @ci_job
Feature: Create and delete a Volume for OpenStack as "Authenticated User"

  @api @javascript
  Scenario: Create a volume
    Given I am logged in as user "{{ drupal_user_name }}"
    When I visit "/clouds/openstack/{{ cloud_context }}/volume/add"
    And I should see the heading "Add Openstack Volume"
    And I enter "{{ volume_name }}" for "Name"
    And I enter "{{ volume_size }}" for "Size (GiB)"
    And I press "Save"
    And I wait for AJAX to finish
    Then the url should match "/clouds/openstack/{{ cloud_context }}/volume"
    And I should see the success message "has been created"
    And I should see neither error nor warning messages
    And I should see "{{ volume_name }}"

  @api @javascript
  Scenario: read the volume
    Given I am logged in as user "{{ drupal_user_name }}"
    When I visit "/clouds/openstack/{{ cloud_context }}/volume"
    And I click "Refresh"
    And I should see the link "{{ volume_name }}"
    And I wait {{ wait }} milliseconds
    And I click "{{ volume_name }}"
    Then the url should match "/clouds/openstack/{{ cloud_context }}/volume/"
    And I should see "{{ volume_name }}"
    And I should see "{{ volume_size }}"
    And I should see neither error nor warning messages

  @api @javascript
  Scenario: attach the volume to an instance
    Given I am logged in as user "{{ drupal_user_name }}"
    When I visit "/clouds/openstack/{{ cloud_context }}/volume"
    And I click "Refresh"
    And I should see the link "{{ volume_name }}"
    And I wait {{ wait }} milliseconds
    And I click "{{ volume_name }}"
    Then the url should match "/clouds/openstack/{{ cloud_context }}/volume/"
    And I click "Attach"
    Then the url should match "/attach"
    And I enter "{{ volume_device_name }}" for "Device Name"
    And I select "{{ instance_name }}" from "Instance ID"
    And I press "Attach"
    Then the url should match "/clouds/openstack/{{ cloud_context }}/volume"
    Then I should see the success message "is attaching to"
    And I click "Refresh"
    And I should see "{{ instance_name }}" in the "{{ volume_name }}" row
    And I should see "in-use" in the "{{ volume_name }}" row

  @api @javascript
  Scenario: detach the volume from an instance
    Given I am logged in as user "{{ drupal_user_name }}"
    When I visit "/clouds/openstack/{{ cloud_context }}/volume"
    And I click "Refresh"
    And I should see the link "{{ volume_name }}"
    And I wait {{ wait }} milliseconds
    And I click "{{ volume_name }}"
    Then the url should match "/clouds/openstack/{{ cloud_context }}/volume/"
    And I click "Detach"
    Then the url should match "/detach"
    And I press "Detach"
    Then the url should match "/clouds/openstack/{{ cloud_context }}/volume"
    Then I should see the success message "is detaching from"
    And I click "Refresh"
    And I should see "available" in the "{{ volume_name }}" row

  @api @javascript
  Scenario: delete the volume
    Given I am logged in as user "{{ drupal_user_name }}"
    When I visit "/clouds/openstack/{{ cloud_context }}/volume"
    And I click "Refresh"
    And I should see the link "{{ volume_name }}"
    And I wait {{ wait }} milliseconds
    And I click "{{ volume_name }}"
    Then the url should match "/clouds/openstack/{{ cloud_context }}/volume/"
    And I click "Delete"
    Then the url should match "/delete"
    And I press "Delete"
    Then I should be on "/clouds/openstack/{{ cloud_context }}/volume"
    And I should see the success message "has been deleted"
    And I should see neither error nor warning messages
    And I click "Refresh"
    And I should not see the link "{{ volume_name }}"
